<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTextMessageOutbox ArrayType
 * @subpackage Arrays
 */
class ArrayOfTextMessageOutbox extends AbstractStructArrayBase
{
    /**
     * The TextMessageOutbox
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TextMessageOutbox[]
     */
    public $TextMessageOutbox;
    /**
     * Constructor method for ArrayOfTextMessageOutbox
     * @uses ArrayOfTextMessageOutbox::setTextMessageOutbox()
     * @param \StructType\TextMessageOutbox[] $textMessageOutbox
     */
    public function __construct(array $textMessageOutbox = array())
    {
        $this
            ->setTextMessageOutbox($textMessageOutbox);
    }
    /**
     * Get TextMessageOutbox value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TextMessageOutbox[]|null
     */
    public function getTextMessageOutbox()
    {
        return isset($this->TextMessageOutbox) ? $this->TextMessageOutbox : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTextMessageOutbox method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTextMessageOutbox method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTextMessageOutboxForArrayConstraintsFromSetTextMessageOutbox(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTextMessageOutboxTextMessageOutboxItem) {
            // validation for constraint: itemType
            if (!$arrayOfTextMessageOutboxTextMessageOutboxItem instanceof \StructType\TextMessageOutbox) {
                $invalidValues[] = is_object($arrayOfTextMessageOutboxTextMessageOutboxItem) ? get_class($arrayOfTextMessageOutboxTextMessageOutboxItem) : sprintf('%s(%s)', gettype($arrayOfTextMessageOutboxTextMessageOutboxItem), var_export($arrayOfTextMessageOutboxTextMessageOutboxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TextMessageOutbox property can only contain items of type \StructType\TextMessageOutbox, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TextMessageOutbox value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageOutbox[] $textMessageOutbox
     * @return \ArrayType\ArrayOfTextMessageOutbox
     */
    public function setTextMessageOutbox(array $textMessageOutbox = array())
    {
        // validation for constraint: array
        if ('' !== ($textMessageOutboxArrayErrorMessage = self::validateTextMessageOutboxForArrayConstraintsFromSetTextMessageOutbox($textMessageOutbox))) {
            throw new \InvalidArgumentException($textMessageOutboxArrayErrorMessage, __LINE__);
        }
        if (is_null($textMessageOutbox) || (is_array($textMessageOutbox) && empty($textMessageOutbox))) {
            unset($this->TextMessageOutbox);
        } else {
            $this->TextMessageOutbox = $textMessageOutbox;
        }
        return $this;
    }
    /**
     * Add item to TextMessageOutbox value
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageOutbox $item
     * @return \ArrayType\ArrayOfTextMessageOutbox
     */
    public function addToTextMessageOutbox(\StructType\TextMessageOutbox $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TextMessageOutbox) {
            throw new \InvalidArgumentException(sprintf('The TextMessageOutbox property can only contain items of type \StructType\TextMessageOutbox, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TextMessageOutbox[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TextMessageOutbox|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TextMessageOutbox|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TextMessageOutbox|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TextMessageOutbox|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TextMessageOutbox|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TextMessageOutbox
     */
    public function getAttributeName()
    {
        return 'TextMessageOutbox';
    }
}
